routes/web.php
<?php

use App\Http\Controllers\PublicApiDataController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => 'locale'], function () {
    Auth::routes(['verify' => true]);

    Route::get('/', 'HomeController@index')->name('home');
    Route::get('/about', 'StaticPageController@showAboutPage')->name('about');
    Route::any('/logout', '\App\Http\Controllers\Auth\LoginController@logout')->name('logout');
    Route::get('/products', 'StaticPageController@showProductsPage')->name('products');
    Route::get('/privacy-policy', 'StaticPageController@showPrivacyPolicyPage')->name('terms');
    Route::get('/dashboard', 'StaticPageController@showDashboard')->name('front::dashboard')->middleware(['auth']);
    Route::get('/locale/switch/{lang}', 'StaticPageController@localeSwitch')->name('locale::switch');

    Route::get('/categories', [PublicApiDataController::class, 'getCategories'])->name('api.front.categories');
    Route::get('/languages', [PublicApiDataController::class, 'getLanguages'])->name('api.front.languages');
    Route::get('/states', [PublicApiDataController::class, 'getStates'])->name('api.front.states');
    Route::get('/sectors', [PublicApiDataController::class, 'getSectors'])->name('api.front.sectors');

    Route::group(['prefix' => 'contact'], function() {
        Route::get('/', 'ContactController@showContactPage')->name('contact');
        Route::post('/submit', 'ContactController@saveContact')->name('contact::submit');
    });

    Route::group(['prefix' => 'user'], function() {
        Route::get('/verification/{token}', 'UserVerificationController@verify')->name('user_verification');
    });

    Route::group(['prefix' => 'search'], function() {
        Route::any('/', 'SearchController@index')->name('search::index');
        Route::any('/latest', 'SearchController@getRecentDocuments')->name('search::latest');
        Route::any('/all', 'SearchController@getAllDocuments')->name('search::all');
        Route::post('/documents', 'SearchController@searchDocuments')->name('search::documents');
        Route::post('/update', 'SearchController@updateSearch')->name('search::update-search');
    });

    Route::group(['prefix' => 'document'], function() {
        Route::any('/get/{file}', 'ViewDocumentController@download')->name('document::download');
        Route::get('/pdf', 'ViewDocumentController@showPdfViewer')->name('document::pdf_viewer');
        Route::any('/view/{id}', 'ViewDocumentController@view')->name('document::view');
        Route::any('/related/{categoryId}', 'ViewDocumentController@getRelatedDocuments')->name('document.related');
    });

    Route::group(['prefix' => 'blog'], function () {
        Route::get('/', 'BlogController@showHome')->name('blog::home');
        Route::get('/all', 'BlogController@showAllPosts')->name('blog::all');
        Route::get('/category/{id}-{slug}', 'BlogController@showCategoryPosts')->name('blog::category');
        Route::get('/post/{id}-{slug}', 'BlogController@showPost')->name('blog::post');
    });

    Route::group(['prefix' => 'admin', 'middleware' => ['role:Administrador|Superadmin']], function() {
        Route::get('/', 'HomeController@indexAdmin')->name('dashboard');

        Route::group(['prefix' => 'languages'], function(){
            Route::get('/', 'LanguageController@list')->name('admin::languages::list');
    
            Route::get('/create', 'LanguageController@create')->name('admin::languages::create');
            Route::post('/store', 'LanguageController@store')->name('admin::languages::store');
    
            Route::get('/edit/{id}', 'LanguageController@edit')->name('admin::languages::edit');
            Route::post('/update/{id}', 'LanguageController@update')->name('admin::languages::update');
        });

        Route::group(['prefix' => 'countries'], function(){
            Route::get('/', 'CountryController@list')->name('admin::countries::list');
    
            Route::get('/create', 'CountryController@create')->name('admin::countries::create');
            Route::post('/store', 'CountryController@store')->name('admin::countries::store');
    
            Route::get('/edit/{id}', 'CountryController@edit')->name('admin::countries::edit');
            Route::post('/update/{id}', 'CountryController@update')->name('admin::countries::update');
        });

        Route::group(['prefix' => 'states'], function(){
            Route::get('/', 'StateController@list')->name('admin::states::list');
    
            Route::get('/create', 'StateController@create')->name('admin::states::create');
            Route::post('/store', 'StateController@store')->name('admin::states::store');
    
            Route::get('/edit/{id}', 'StateController@edit')->name('admin::states::edit');
            Route::post('/update/{id}', 'StateController@update')->name('admin::states::update');
        });

        Route::group(['prefix' => 'sectors'], function(){
            Route::get('/', 'SectorController@list')->name('admin::sectors::list');
    
            Route::get('/create', 'SectorController@create')->name('admin::sectors::create');
            Route::post('/store', 'SectorController@store')->name('admin::sectors::store');
    
            Route::get('/edit/{id}', 'SectorController@edit')->name('admin::sectors::edit');
            Route::post('/update/{id}', 'SectorController@update')->name('admin::sectors::update');
        });

        Route::group(['prefix' => 'categories'], function(){
            Route::get('/', 'CategoryController@list')->name('admin::categories::list');
    
            Route::get('/create', 'CategoryController@create')->name('admin::categories::create');
            Route::post('/store', 'CategoryController@store')->name('admin::categories::store');
    
            Route::get('/edit/{id}', 'CategoryController@edit')->name('admin::categories::edit');
            Route::post('/update/{id}', 'CategoryController@update')->name('admin::categories::update');

            Route::get('/delete/{id}', 'CategoryController@delete')->name('admin::categories::delete');
        });
    
        Route::group(['prefix' => 'users'], function(){
            Route::get('/', 'UserController@list')->name('admin::users::list');
            Route::any('/data', 'UserController@dataTable')->name('admin::users::data');
            Route::any('/download', 'UserController@downloadUserList')->name('admin::users::download');
    
            Route::get('/create', 'UserController@create')->name('admin::users::create');
            Route::post('/store', 'UserController@store')->name('admin::users::store');
    
            Route::get('/edit/{id}', 'UserController@edit')->name('admin::users::edit');
            Route::post('/update/{id}', 'UserController@update')->name('admin::users::update');

            Route::get('/delete/{id}', 'UserController@delete')->name('admin::users::delete');

            Route::get('/approval', 'UserApprovalController@showIndex')->name('admin::users_approval::list');
            Route::post('/approval/save', 'UserApprovalController@saveApproval')->name('admin::users_approval::save');
            Route::any('/approval/data', 'UserApprovalController@returnDataTable')->name('admin::users_approval::data');
            
            Route::any('/verification/send/{userId}', 'UserApprovalController@sendVerificationLink')->name('admin::users_verification::send');
        });

        Route::group(['prefix' => 'contact'], function() {
            Route::get('/', 'AdminContactController@list')->name('admin::contact::list');
            Route::any('/data', 'AdminContactController@returnDataTable')->name('admin::contact::data');
            Route::any('/view/{id}', 'AdminContactController@view')->name('admin::contact::view');
        });
    
        Route::group(['prefix' => 'blog'], function() {
            Route::group(['prefix' => 'categories'], function() {
                Route::get('/', 'BlogCategoryController@list')->name('admin::blog_categories::list');
                Route::any('/data', 'BlogCategoryController@dataTable')->name('admin::blog_categories::data');
        
                Route::get('/create', 'BlogCategoryController@create')->name('admin::blog_categories::create');
                Route::post('/store', 'BlogCategoryController@store')->name('admin::blog_categories::store');
        
                Route::get('/edit/{id}', 'BlogCategoryController@edit')->name('admin::blog_categories::edit');
                Route::post('/update/{id}', 'BlogCategoryController@update')->name('admin::blog_categories::update');

                Route::get('/delete/{id}', 'BlogCategoryController@delete')->name('admin::blog_categories::delete');
            });

            Route::get('/', 'BlogContentController@list')->name('admin::blog_posts::list');
            Route::any('/data', 'BlogContentController@dataTable')->name('admin::blog_posts::data');
    
            Route::get('/create', 'BlogContentController@create')->name('admin::blog_posts::create');
            Route::post('/store', 'BlogContentController@store')->name('admin::blog_posts::store');
    
            Route::get('/edit/{id}', 'BlogContentController@edit')->name('admin::blog_posts::edit');
            Route::post('/update/{id}', 'BlogContentController@update')->name('admin::blog_posts::update');

            Route::get('/delete/{id}', 'BlogContentController@delete')->name('admin::blog_posts::delete');
        });

        Route::group(['prefix' => 'documents'], function() {
            Route::get('/', 'DocumentController@list')->name('admin::documents::list');

app/Http/Controllers/BlogController.php
<?php

namespace App\Http\Controllers;

use App\BlogCategory;
use App\BlogContent;
use App\BlogUserAction;
use App\Category;
use App\Search;
use App\Traits\ContentTrait;
use Illuminate\Http\Request;
use Artesaos\SEOTools\Facades\SEOMeta;
use Artesaos\SEOTools\Facades\OpenGraph;
use Artesaos\SEOTools\Facades\TwitterCard;
use Illuminate\Support\Facades\DB;

class BlogController extends Controller
{
    use ContentTrait;

    public function showHome() {
        $posts = BlogContent::with(['categories', 'author'])->isPost()->active()->orderBy('created_at', 'desc')->limit(6)->get();
        $lastPost = BlogContent::with(['categories', 'author'])->isPost()->active()->orderBy('created_at', 'desc')->limit(1)->first();
        $categories = BlogCategory::with(['posts' => function($q) {
                $q->active()->orderBy('created_at', 'desc');
            }, 'posts.author', 'posts.categories'])
            ->whereHas('posts')
            ->orderBy('name_es')->get();
        $docCategories = Category::orderBy('name_es')->get();

        SEOMeta::setTitle(__("Blog & Noticias"));
        SEOMeta::setDescription("");

        OpenGraph::setDescription("");
        OpenGraph::setTitle(__("Blog & Noticias"));

        return view('frontoffice.blog.home', compact('posts', 'lastPost', 'categories', 'docCategories'));
    }

    public function showAllPosts() {
        $posts = BlogContent::isPost()->active()->with(['categories', 'author'])->orderBy('created_at', 'desc')->get();
        $categories = []; //CategoriaBlog::orderBy('name_es')->get();
        $docCategories = Category::orderBy('name_es')->get();
        return view('frontoffice.blog.all', compact('posts', 'categories', 'docCategories'));
    }

    public function showCategoryPosts($id, $slug) {
        $category = BlogCategory::where('id', $id)->where('slug', $slug)->with([
            'posts' => function($q) {
                $q->active();
            }, 
            'posts.categories', 'posts.author'
        ])->first();
        if (empty($category)) {
            return back()
                ->with(['message_error' => __("Categoría no encontrada")]);
        }

        $categories = []; //CategoriaBlog::orderBy('name_es')->get();
        $docCategories = Category::orderBy('name_es')->get();

        $category->views += 1;
        $category->save();

        return view('frontoffice.blog.category', compact('category', 'categories', 'docCategories'));
    }

    public function showPost(Request $request, $id, $slug) {
        $post = BlogContent::where('id', $id)->where('slug', $slug)->active()->isPost()->with(['categories', 'author'])->first();
        
        if (empty($post)) {
            return back()
                ->with(['message_error' => __("Post no encontrado")]);
        }

        $categories = BlogCategory::whereHas('posts', 
            function($q) {
                $q->active();
            })
            ->orderBy('name_es')
            ->withCount([
                'posts'  => function($q) {
                    $q->active();
                }
            ])
            ->get();

        $docCategories = Category::orderBy('name_es')->get();
        $recents = BlogContent::where('id', '<>', $id)->active()->orderBy('created_at', 'desc')->limit(5)->get();
        $related = [];
        if (!empty($post->categories)) {
            $postCategories = $post->categories->pluck('id')->all();
            $related = BlogContent::where('id', '<>', $id)
                ->active()
                ->whereHas('categories', function($q) use ($postCategories) {
                    $q->whereIn('blog_category.id', $postCategories);
                })
                ->with(['categories', 'author'])
                ->limit(3)
                ->orderBy("created_at", "desc")
                ->get();
        }

        $desc = $post->getDescription();
        SEOMeta::setTitle($post->title());
        SEOMeta::setDescription($desc);
        //SEOMeta::setCanonical('https://codecasts.com.br/lesson');

        OpenGraph::setDescription($desc);
        OpenGraph::setTitle($post->title());
        OpenGraph::setUrl(url()->current());
        OpenGraph::addProperty('type', 'articles');

        TwitterCard::setTitle($post->title());

        $html = $this->getHtmlSection($post, $id);

        $post->views += 1;
        $post->save();

        if (\Auth::check()) {
            $action = new BlogUserAction();
            $action->ip_address = $request->ip();
            $action->action = 'view';
            $action->user_id = \Auth::user()->id;
            $action->blog_content_id = $post->id;
            $action->save();
        }

        return view('frontoffice.blog.post', compact('post', 'html', 'categories', 'docCategories', 'related', 'recents'));
    }
}

resources/views/frontoffice/blog/all.blade.php
@extends('frontoffice.layouts.app')

@section('js')
@endsection

@section('content')
@php
/*@component('frontoffice.components.search_form', ['categories' => $docCategories])
@endcomponent*/
@endphp

<section class="doc_blog_grid_area">
    <div class="container">
        <div class="row blog_grid_tab">
        @include('frontoffice.blog.post_list', ['posts' => $posts])
        </div>
    </div>
</section>
@stop

resources/views/frontoffice/blog/category.blade.php
@extends('frontoffice.layouts.app')

@section('js')
@endsection

@section('content')
@php
/*@component('frontoffice.components.search_form', ['categories' => $docCategories])
@endcomponent*/
@endphp

<section class="mt-40">
    <div class="container">
        <br />
        <h2 class="text-center">{{ $category->name() }}</h2>
    </div>
</div>
<section class="doc_blog_grid_area">
    <div class="container">
        <div class="row blog_grid_tab">
        @include('frontoffice.blog.post_list', ['posts' => $category->posts])
        </div>
    </div>
</section>
@stop

resources/views/frontoffice/blog/home.blade.php
@extends('frontoffice.layouts.app')

@section('js')
@endsection

@section('content')
@php
/*@component('frontoffice.components.search_form', ['categories' => $docCategories])
@endcomponent*/
@endphp

<section class="blog_top_post_area sec_pad bg_color">
    <div class="container">
        <div class="row blog_top_post flex-row-reverse">
            <div class="col-lg-7 p_top_img">
                <img class="p_img img-fluid" src="{{ asset($lastPost->getImageUrl('featured')) }}" alt="" />
            </div>
            <div class="col-lg-5 p-0">
                <div class="b_top_post_content">
                    <div class="post_tag">
                        @foreach ($lastPost->categories as $category)
                        <a class="c_blue" href="{{ route('blog::category', ['id' => $category->id, 'slug' => $category->slug]) }}">
                            {{ $category->name() }}
                        </a>
                        @endforeach
                    </div>
                    <a href="{{ route("blog::post", ['id' => $lastPost->id, 'slug' => $lastPost->slug]) }}">
                        <h3>{{ $lastPost->title() }}</h3>
                    </a>
                    <p>{{ $lastPost->getDescription() }}</p>
                    <a href="{{ route("blog::post", ['id' => $lastPost->id, 'slug' => $lastPost->slug]) }}" class="learn_btn">{{ __("Continuar leyendo") }}<i class="arrow_right"></i></a>
                    <div class="media post_author">
                        <!--div class="round_img">
                            <img src="img/blog-grid/ansley.jpg" alt="">
                        </div-->
                        <div class="media-body author_text">
                            <h4>{{ $lastPost->author->name }}</h4>
                            <div class="date">{{ $lastPost->created_at }}</div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

<section class="doc_blog_grid_area">
    <div class="blog_grid_inner bg_color">
        <div class="container">
            <ul class="nav blog_tab nav-tabs" role="tablist">
                <li class="nav-item">
                    <a class="nav-link active" href="#all-posts" data-toggle="tab" role="tab" aria-controls="all-posts-tab" aria-selected="true">
                        {{ __("Todos") }}
                    </a>
                </li>
                @foreach($categories as $category)
                <li class="nav-item">
                    <a class="nav-link" href="#{{ $category->slug }}" data-toggle="tab" role="tab" aria-controls="{{ $category->slug }}" aria-selected="{{ $loop->first ? 'true' : 'false' }}">
                        {{ $category->name() }}
                    </a>
                </li>
                @endforeach
            </ul>
        </div>
    </div>
    <div class="tab-content">
        <div class="tab-pane fade active show" id="all-posts" role="tabpanel" aria-labelledby="all-posts-tab">
            <div class="container">
                <div class="row blog_grid_tab">
                    @include('frontoffice.blog.post_list', ['posts' => $posts])
                    <div class="col-sm-12 text-center">
                        <br />
                        <p><a href="{{ route('blog::all') }}" class="btn btn-blue wide">{{ __("Más entradas") }} <i class="fas fa-arrow-right"></i></a></p>
                    </div>
                </div>
            </div>
        </div>

        @foreach($categories as $category)

        @if(!empty($category->posts))
        <div class="tab-pane fade" id="{{ $category->slug }}" role="tabpanel" aria-labelledby="{{ $category->slug }}-tab">
            <div class="container">
                <div class="row blog_grid_tab">
                    @include('frontoffice.blog.post_list', ['posts' => $category->posts->take(6)])
                    <div class="col-sm-12 text-center">
                        <br />
                        <p><a href="{{ route('blog::category', ['id' => $category->id, 'slug' => $category->slug]) }}" class="btn btn-blue wide">{{ __("Más entradas") }} <i class="fas fa-arrow-right"></i></a></p>
                    </div>
                </div>
            </div>
        </div>
        @endif

        @endforeach
    </div>
</section>
@stop

resources/views/frontoffice/blog/post.blade.php
@extends('frontoffice.layouts.app')

@section('js')
@endsection

@section('content')
@php
/*@component('frontoffice.components.search_form', ['categories' => $docCategories])
@endcomponent*/
@endphp

<section class="mt-40">
    <div class="container">
        <div class="breadcrumb_content">
            <br />
            <h2>{{ $post->title() }}</h2>
            <div class="single_post_author">
                <!--img class="author_img" src="img/blog-single/author_single.jpg" alt=""-->
                <div class="text">
                    <a href="#">
                        <h4>{{ $post->author->name }}</h4>
                    </a>
                    <div class="post_tag">
                        <a href="#">{{ $post->created_at }}</a>
                        @foreach ($post->categories as $category)
                        <a class="c_blue" href="{{ route('blog::category', ['id' => $category->id, 'slug' => $category->slug]) }}">
                            {{ $category->name() }}
                        </a>
                        @endforeach
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

<section class="blog_area">
    <div class="container">
        <div class="row">
            <div class="col-lg-8">
                <div class="blog_single_info">
                    <div class="blog_single_item">
                        <div class="blog_single_img">
                            <img src="{{ asset($post->getImageUrl('inner')) }}" alt="" class="img-fluid w-100" />
                        </div>
                        {!! $html !!}
                    </div>

                    @if(!empty($related) && count($related) > 0)
                    <div class="blog_related_post">
                        <h2 class="c_head">{{ __("Post relacionados") }}</h2>
                        <div class="row">
                            @include('frontoffice.blog.post_list', ['posts' => $related])
                        </div>
                    </div>
                    @endif
                </div>
            </div>
            <div class="col-lg-4">
                <div class="blog_sidebar pl-40">
                    <div class="widget categorie_widget">
                        <h4 class="c_head">{{ __("Categorías") }}</h4>
                        <ul class="list-unstyled categorie_list">
                            @foreach ($categories as $category)
                            <li>
                                <a href="{{ route('blog::category', ['id' => $category->id, 'slug' => $category->slug]) }}">
                                    {{ $category->name() }} <span>({{ $category->posts_count }})</span>
                                </a>
                            </li>
                            @endforeach
                        </ul>
                    </div>
                    @if(!empty($recents) && count($recents) > 0)
                    <div class="widget recent_news_widget">
                        <h4 class="c_head">{{ __("Posts recientes") }}</h4>
                        @foreach($recents as $recent)
                        <div class="media recent_post_item">
                            <img src="{{ asset($recent->getImageUrl('tiny')) }}" alt="" class="img-fluid" />
                            <div class="media-body">
                                <a href="{{ route("blog::post", ['id' => $recent->id, 'slug' => $recent->slug]) }}">
                                    <h5>{{ $recent->title() }}</h5>
                                </a>
                                <div class="entry_post_date">{{ $recent->created_at }}</div>
                            </div>
                        </div>
                        @endforeach
                    </div>
                    @endif
                    <!--div class="widget tag_widget">
                        <h4 class="c_head">Tags</h4>
                        <ul class="list-unstyled w_tag_list">
                            <li><a href="#">Design</a></li>
                            <li><a href="#">Apps</a></li>
                            <li><a href="#">Photography</a></li>
                        </ul>
                    </div-->
                </div>
            </div>
        </div>
    </div>
</section>
@stop

resources/views/frontoffice/blog/post_list.blade.php
@foreach ($posts as $post)
<div class="col-lg-4 col-sm-6">
    <div class="blog_grid_post fadeInUp">
        <img src="{{ asset($post->getImageUrl('thumbnail')) }}" alt="" class="img-fluid" />
        <div class="grid_post_content">
            <div class="post_tag">
                @foreach ($post->categories as $category)
                <a class="c_blue" href="{{ route('blog::category', ['id' => $category->id, 'slug' => $category->slug]) }}">
                    {{ $category->name() }}
                </a>
                @endforeach
            </div>
            <a href="{{ route("blog::post", ['id' => $post->id, 'slug' => $post->slug]) }}">
                <h4 class="b_title">{{ $post->title() }}</h4>
            </a>
            <p>{{ $post->getDescription() }}...</p>
            <div class="media post_author">
                <!--div class="round_img">
                    <img src="img/blog-grid/author_1.jpg" alt="">
                </div-->
                <div class="media-body author_text">
                    <h4>{{ $post->author->name }}</h4>
                    <div class="date">{{ $post->created_at }}</div>
                </div>
            </div>
        </div>
    </div>
</div>
@endforeach